    {{#oneofFieldCase}}
    static private {{domainFullName}} toDomain_{{oneofFieldCase}}({{protoClass}} proto) {
        {{domainFullName}} domainObject = null;
    {{/oneofFieldCase}}
    {{^oneofFieldCase}}
    /**
    * Convert a proto object into the respective domain object or update the give domain object.
    * @param proto The protobuf object to be converted
    * @param domainObject if null then create a new object of the type. If not null then update the given object using setter methods
    */
    public static {{domainFullName}} toDomain({{protoClass}} proto, {{domainFullName}} domainObject) {
    {{/oneofFieldCase}}
        {{domainFullName}} domain = domainObject;
        if(domainObject == null) {
    {{#hasMapper}}
            {{mapperFullName}} mapper = new {{mapperFullName}}();
            return mapper.toDomain(proto);
    {{/hasMapper}}
    {{^hasMapper}}
        {{#oneofBaseClassData}}
            switch (proto.get{{oneofProtoName}}Case()) {
            {{#oneOfFieldsData}}

                case {{oneofFieldCase}}:
                {{#isMessage}}
                    return toDomain(proto.get{{oneOfProtoField}}(), ({{oneofImplClass}}) null);
                {{/isMessage}}
                {{^isMessage}}
                    return toDomain_{{oneofFieldCase}}(proto);
                {{/isMessage}}
            {{/oneOfFieldsData}}
                default:
                    throw new RuntimeException("Unhandled oneof proto field: " + proto.get{{oneofProtoName}}Case());
            }
        {{/oneofBaseClassData}}
        {{^oneofBaseClassData}}
        {{#builderData}}
            var domainBuilder = {{domainFullName}}.{{builderMethodName}}();
{{> to_domain_builder}}
            domain = domainBuilder.{{buildMethodName}}();
            {{/builderData}}
            {{^builderData}}
            domain = new {{domainFullName}}(
                {{#constructorParameters}}
{{> field_to_domain}}{{^isLast}}                ,{{/isLast}}
                {{/constructorParameters}}
            );
            {{/builderData}}
        {{/oneofBaseClassData}}
    {{/hasMapper}}
        }
    {{#hasSetters}}
{{> to_domain_setters}}
    {{/hasSetters}}
        return domain;

    }